summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2011-10-16 12:07:05 +0200
committerJim Meyering <meyering@redhat.com>2011-10-17 17:44:54 +0200
commit537f9da37fa396af72d8b3e6af274e0bcbeab794 (patch)
tree80c465e50d6b124ccc56b6bf7764738480f65559
parent60cd4c271d35eb94bbf04e07425502ed3bb8697c (diff)
downloadcoreutils-537f9da37fa396af72d8b3e6af274e0bcbeab794.tar.xz
tac: don't misbehave with multiple non-seekable inputs
* src/tac.c (copy_to_temp): Do not reuse the template buffer. Instead, scribble only on a freshly-xstrdup'd copy each time. Free that buffer both here, upon failure, and ... (tac_nonseekable): ...free the buffer in caller, upon success. * tests/misc/tac-2-nonseekable: New file. * tests/Makefile.am (TESTS): Add it. * NEWS (Bug fixes): Mention it. Reported by Ambrose Feinstein in http://debbugs.gnu.org/9762.
-rw-r--r--NEWS5
-rw-r--r--src/tac.c19
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/misc/tac-2-nonseekable27
4 files changed, 48 insertions, 4 deletions
diff --git a/NEWS b/NEWS
index 4c8e162c7..3ed44b284 100644
--- a/NEWS
+++ b/NEWS
@@ -2,6 +2,11 @@ GNU coreutils NEWS -*- outline -*-
* Noteworthy changes in release ?.? (????-??-??) [?]
+** Bug fixes
+
+ tac no longer fails to handle two or more non-seekable inputs
+ [bug introduced in coreutils-5.3.0]
+
* Noteworthy changes in release 8.14 (2011-10-12) [stable]
diff --git a/src/tac.c b/src/tac.c
index 16b918303..2898199a2 100644
--- a/src/tac.c
+++ b/src/tac.c
@@ -447,12 +447,13 @@ copy_to_temp (FILE **g_tmp, char **g_tempfile, int input_fd, char const *file)
FIXME: clean up upon fatal signal. Don't block them, in case
$TMPFILE is a remote file system. */
- char *tempfile = template;
- int fd = mkstemp (template);
+ char *tempfile = xstrdup (template);
+ int fd = mkstemp (tempfile);
if (fd < 0)
{
error (0, errno, _("cannot create temporary file in %s"),
quote (tempdir));
+ free (tempfile);
return false;
}
@@ -462,6 +463,7 @@ copy_to_temp (FILE **g_tmp, char **g_tempfile, int input_fd, char const *file)
error (0, errno, _("cannot open %s for writing"), quote (tempfile));
close (fd);
unlink (tempfile);
+ free (tempfile);
return false;
}
@@ -497,6 +499,7 @@ copy_to_temp (FILE **g_tmp, char **g_tempfile, int input_fd, char const *file)
Fail:
fclose (tmp);
+ free (tempfile);
return false;
}
@@ -508,8 +511,16 @@ tac_nonseekable (int input_fd, const char *file)
{
FILE *tmp_stream;
char *tmp_file;
- return (copy_to_temp (&tmp_stream, &tmp_file, input_fd, file)
- && tac_seekable (fileno (tmp_stream), tmp_file));
+ if (copy_to_temp (&tmp_stream, &tmp_file, input_fd, file))
+ {
+ if (tac_seekable (fileno (tmp_stream), tmp_file))
+ {
+ free (tmp_file);
+ return true;
+ }
+ }
+
+ return false;
}
/* Print FILE in reverse, copying it to a temporary
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 9c9a1b8c1..5021c1844 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -274,6 +274,7 @@ TESTS = \
misc/sum-sysv \
misc/tac \
misc/tac-continue \
+ misc/tac-2-nonseekable \
misc/tail \
misc/tee \
misc/tee-dash \
diff --git a/tests/misc/tac-2-nonseekable b/tests/misc/tac-2-nonseekable
new file mode 100755
index 000000000..7b4877367
--- /dev/null
+++ b/tests/misc/tac-2-nonseekable
@@ -0,0 +1,27 @@
+#!/bin/sh
+# ensure that tac works with two or more non-seekable inputs
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ tac
+
+echo x | tac - - > out 2> err || fail=1
+echo x > exp || fail=1
+compare out exp || fail=1
+compare err /dev/null || fail=1
+
+Exit $fail